Main Page Namespace List Class Hierarchy Alphabetical List Compound List File List Compound Members File Members

# gnExceptionCode.h File Reference

`#include "gn/gnDefs.h"`
`#include <string>`

Go to the source code of this file.

## Compounds
class | gnExceptionCode
## Defines
#define | CREATE_EXCEPTION(E_NAME)
## Functions
GNDLLEXPORT uint32 & | GetNewExceptionCode ()
gnExceptionCode & | IndexOutOfBounds ()
| Thrown when a generic array index is too large or otherwise invalid.
gnExceptionCode & | SeqIndexOutOfBounds ()
| Thrown when a sequence index references an invalid coordinate.
gnExceptionCode & | FragmentIndexOutOfBounds ()
| Thrown when a fragment index references an invalid fragment.
gnExceptionCode & | ContigIndexOutOfBounds ()
| Thrown when a contig index references an invalid contig.
gnExceptionCode & | HeaderIndexOutOfBounds ()
| Thrown when a header index references an invalid header.
gnExceptionCode & | SpecIndexOutOfBounds ()
| Thrown when a spec index references an invalid spec.
gnExceptionCode & | FeatureIndexOutOfBounds ()
| Thrown when a feature index references an invalid feature.
gnExceptionCode & | FileNotOpened ()
| Thrown when a file can't be opened.
gnExceptionCode & | URLNotFound ()
| Thrown when a URL can't be opened.
gnExceptionCode & | FileUnreadable ()
| Thrown when a file's data is corrupt or unreadable.
gnExceptionCode & | IOStreamFailed ()
| Thrown when an operation on a stream fails.
gnExceptionCode & | NullPointer ()
| Thrown when an invalid pointer is given.

## Define Documentation

#define CREATE_EXCEPTION | ( | E_NAME |  | ) |

| Value:
    inline \
    static gnExceptionCode& E_NAME(){ \
            static gnExceptionCode* m_excp = new gnExceptionCode(GetNewExceptionCode(), #E_NAME); \
            return *m_excp; \
    }
Definition at line 54 of file gnExceptionCode.h.

## Function Documentation

gnExceptionCode& ContigIndexOutOfBounds | ( |  | ) | `[inline, static]`

| Thrown when a contig index references an invalid contig. Definition at line 79 of file gnExceptionCode.h. Referenced by gnFragmentSpec::GetSpec(), and gnFragmentSpec::RemoveSpec().

gnExceptionCode& FeatureIndexOutOfBounds | ( |  | ) | `[inline, static]`

| Thrown when a feature index references an invalid feature. Definition at line 91 of file gnExceptionCode.h. Referenced by gnGenomeSpec::GetFeature(), gnGenomeSpec::RemoveFeature(), and gnFragmentSpec::RemoveFeature().

gnExceptionCode& FileNotOpened | ( |  | ) | `[inline, static]`

| Thrown when a file can't be opened. Definition at line 95 of file gnExceptionCode.h. Referenced by gnSourceFactory::AddSource(), gnFileSource::Open(), and gnFASSource::Write().

gnExceptionCode& FileUnreadable | ( |  | ) | `[inline, static]`

| Thrown when a file's data is corrupt or unreadable. Definition at line 103 of file gnExceptionCode.h.

gnExceptionCode& FragmentIndexOutOfBounds | ( |  | ) | `[inline, static]`

| Thrown when a fragment index references an invalid fragment. Definition at line 75 of file gnExceptionCode.h. Referenced by gnGenomeSpec::GetSpec(), and gnGenomeSpec::MergeFragments().

uint32 & GetNewExceptionCode | ( |  | ) | `[inline]`

| Definition at line 42 of file gnExceptionCode.h. References uint32.

gnExceptionCode& HeaderIndexOutOfBounds | ( |  | ) | `[inline, static]`

| Thrown when a header index references an invalid header. Definition at line 83 of file gnExceptionCode.h. Referenced by gnMultiSpec::GetHeader(), and gnMultiSpec::RemoveHeader().

gnExceptionCode& IndexOutOfBounds | ( |  | ) | `[inline, static]`

| Thrown when a generic array index is too large or otherwise invalid. Definition at line 67 of file gnExceptionCode.h. Referenced by gnSourceFactory::DelSource().

gnExceptionCode& IOStreamFailed | ( |  | ) | `[inline, static]`

| Thrown when an operation on a stream fails. Definition at line 107 of file gnExceptionCode.h. Referenced by gnFileSource::Close().

gnExceptionCode& NullPointer | ( |  | ) | `[inline, static]`

| Thrown when an invalid pointer is given. Definition at line 111 of file gnExceptionCode.h. Referenced by gnFileSource::SetFilter().

gnExceptionCode& SeqIndexOutOfBounds | ( |  | ) | `[inline, static]`

| Thrown when a sequence index references an invalid coordinate. Definition at line 71 of file gnExceptionCode.h. Referenced by gnGenomeSpec::AddFeature(), gnSequence::erase(), gnMultiSpec::GetSpecIndexByBase(), gnSequence::insert(), gnSequence::localToGlobal(), gnMultiSpec::SeqRead(), gnSequence::splitContig(), and gnSequence::subseq().

gnExceptionCode& SpecIndexOutOfBounds | ( |  | ) | `[inline, static]`

| Thrown when a spec index references an invalid spec. Definition at line 87 of file gnExceptionCode.h. Referenced by gnMultiSpec::GetSpecEndBase(), gnMultiSpec::GetSpecIndexByName(), gnMultiSpec::GetSpecStartBase(), and gnMultiSpec::SeqRead().

gnExceptionCode& URLNotFound | ( |  | ) | `[inline, static]`

| Thrown when a URL can't be opened. Definition at line 99 of file gnExceptionCode.h.